# coding: utf-8

"""
    Alfresco Content Services REST API

    **Core API**  Provides access to the core features of Alfresco Content Services.   # noqa: E501

    OpenAPI spec version: 1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from alfresco_core_api_client.configuration import Configuration


class DeletedNode(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'archived_by_user': 'UserInfo',
        'archived_at': 'datetime'
    }

    attribute_map = {
        'archived_by_user': 'archivedByUser',
        'archived_at': 'archivedAt'
    }

    def __init__(self, archived_by_user=None, archived_at=None, _configuration=None):  # noqa: E501
        """DeletedNode - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._archived_by_user = None
        self._archived_at = None
        self.discriminator = None

        self.archived_by_user = archived_by_user
        self.archived_at = archived_at

    @property
    def archived_by_user(self):
        """Gets the archived_by_user of this DeletedNode.  # noqa: E501


        :return: The archived_by_user of this DeletedNode.  # noqa: E501
        :rtype: UserInfo
        """
        return self._archived_by_user

    @archived_by_user.setter
    def archived_by_user(self, archived_by_user):
        """Sets the archived_by_user of this DeletedNode.


        :param archived_by_user: The archived_by_user of this DeletedNode.  # noqa: E501
        :type: UserInfo
        """
        if self._configuration.client_side_validation and archived_by_user is None:
            raise ValueError("Invalid value for `archived_by_user`, must not be `None`")  # noqa: E501

        self._archived_by_user = archived_by_user

    @property
    def archived_at(self):
        """Gets the archived_at of this DeletedNode.  # noqa: E501


        :return: The archived_at of this DeletedNode.  # noqa: E501
        :rtype: datetime
        """
        return self._archived_at

    @archived_at.setter
    def archived_at(self, archived_at):
        """Sets the archived_at of this DeletedNode.


        :param archived_at: The archived_at of this DeletedNode.  # noqa: E501
        :type: datetime
        """
        if self._configuration.client_side_validation and archived_at is None:
            raise ValueError("Invalid value for `archived_at`, must not be `None`")  # noqa: E501

        self._archived_at = archived_at

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(DeletedNode, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DeletedNode):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, DeletedNode):
            return True

        return self.to_dict() != other.to_dict()
